//----------------------------------------------------------------------------
// ļSpline.h
//----------------------------------------------------------------------------
// :	ʹ߽вֵ
//----------------------------------------------------------------------------
// ˵	1.ṩֱ߽趨ʽ
//				1)˵һ׵
//				2)˵Ķ׵
//			2.ṩֲֵ㷽ʽ
//				1)һӦֵ,׳ֵ쳣
//				2)Ӧֵ׳ֵ쳣
//				3)趨ֵ(Ϊ2),ԶMax(x)Min(x)֮ȼֵ.
//				xΪ֪Ա,׳쳣
//----------------------------------------------------------------------------
// ߣ Ǳ
// : 2017220
// ޸ڣ
//-----------------------------------------------------------------------------

#ifndef _SPLINE_H
#define _SPLINE_H
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#pragma warning (disable:4290)		//vs2010c++Ժ׳쳣м⣬ֱӺ

//ΪȽ϶,Ϊ˷ֹһռа
namespace SplineSpace		
{
	class SplineFailure		//쳣
	{
	private:
		const char* Message;
	public:
		SplineFailure(const char* msg);
		const char* GetMessage();
	};

	class SplineInterface		//ӿ
	{
	public:
		//ֵ:
		//x->Ա()
		//y->زֵ()
		//xڲֵֵʧ
		virtual bool SinglePointInterp(const double& x,double& y)=0;
		//ֵ:
		//x->Աָ,num->Ա()
		//y->زֵָ()
		virtual bool MultiPointInterp(const double* x,const int& num,double* y)=0;		
		//Զֵ:
		//num->ҪɵĲֵ()
		//x->Աָ()
		//y->ӦϽָ()
		virtual bool AutoInterp(const int& num,double* x,double* y)=0;					

		virtual ~SplineInterface(){};			
	};

	enum BoundaryCondition		//߽ö
	{
		GivenFirstOrder=1		//һ׵
		,GivenSecondOrder		//׵
	};

	class Spline:public SplineInterface				//ʵ
	{
	public:
		//캯:
		//x0->֪Աָ,y0->ָ֪,num->֪ݵĸ
		//bc->߽,Ĭϸ׵
		//leftBoundary,rightBoundaryұ߽絼ֵ,Ĭ϶0
		Spline(const double* x0,const double* y0,const int& num,
			BoundaryCondition bc=GivenSecondOrder,const double& leftBoundary=0,const double& rightBoundary=0);

		bool SinglePointInterp(const double& x,double& y)throw(SplineFailure);		//麯ʵ
		bool MultiPointInterp(const double* x,const int& num,double* y)throw(SplineFailure);
		bool AutoInterp(const int& num,double* x,double* y)throw(SplineFailure);

		~Spline();
		
	private:
		//
		void PartialDerivative1(void);		//һ׵
		void PartialDerivative2(void);		//׵
		//
		const double* GivenX;	//֪ݵԱ
		const double* GivenY;	//֪ݵ
		const int GivenNum;		//֪ݵ
		const BoundaryCondition Bc;	//߽
		const double LeftB;
		const double RightB;

		double* PartialDerivative;	//ӦĶ׻һƫ
		double MaxX;				//Աֵ
		double MinX;				//ԱСֵ

		const double* SplineX;	//ֵԱ
		double* SplineY;		//ֵ
		const int* SplineNum;	//ֵ
	};
}
#endif